// JavaScript Document
var dom = {
		body: document.body,
		rocket: $(".rocket").get(0),
		smallCircleBg_1: $(".smallCircleBg_1").get(0),
		smallCircleBg_2: $(".smallCircleBg_2").get(0),
		smallCircleBg_3: $(".smallCircleBg_3").get(0),
		flyContainer3_content: $(".flyContainer3 .content").get(0) 
	};
	var bodyWidth = parseInt(getStyle(dom.body, "width")) || $(dom.body).width();
	var bodyHeight = parseInt(getStyle(dom.body, "height")) || $(dom.body).height();
	var swipeContainer = document.getElementById('swipeContainer');
	var swipeList = $(swipeContainer).find("li");
	var dotList = $('#dotContainer i');
	var timeoutObjForIndex2 = [];
	function hide() {
		hideForIndex1();
		hideForIndex2();
	}
	function hideForRocket() {
		clearInterval(dom.rocket.timer);
		dom.rocket.style.top = bodyHeight+"px";
		dom.rocket.style.left = "-400px";
	}
	function hideForIndex3() {
		clearInterval(dom.flyContainer3_content.timer);
		dom.flyContainer3_content.style.top = "-"+bodyHeight+"px";
	}
	function hideForDetail() {
		for(var i=0, len=timeoutObjForIndex2.length; i<len; i++) {
			clearTimeout(timeoutObjForIndex2[i]);
		}
		clearInterval(dom.smallCircleBg_1.timer);
		clearInterval(dom.smallCircleBg_2.timer);
		clearInterval(dom.smallCircleBg_3.timer);

		dom.smallCircleBg_1.style.left =  "-350px";
		dom.smallCircleBg_2.style.right = "-250px";
		dom.smallCircleBg_3.style.right = "-300px";
	}
	function showForIndex3() {
		move(dom.flyContainer3_content, {top:{value:0}}, 200);
	}
	function showForRocket() {
		move(dom.rocket, {top:{value:0.15, type:"percent"}, left:{value:0.15, type:"percent"}}, 600);
	}
	function showForDetail() {
		for(var i=0; i<3; i++) {
			(function(index) {
				var delayTime = index*400;
				switch(index) {
					case 0:
						timeoutObjForIndex2[index] = setTimeout(function() {
							move(dom.smallCircleBg_1, {left:{value:0.05, type:"percent"}}, 400, 50);
						}, delayTime);
					break;
					case 1:
						timeoutObjForIndex2[index] = setTimeout(function() {
							move(dom.smallCircleBg_2, {right:{value:0.1, type:"percent"}}, 400, 50);
						}, delayTime);
					break;
					case 2:
						timeoutObjForIndex2[index] = setTimeout(function() {
							move(dom.smallCircleBg_3, {right:{value:0.05, type:"percent"}}, 400, 50);
						}, delayTime);
					break;
				}
			})(i);
		}
	}
	window.mySwipe = Swipe(swipeContainer, {
		startSlide: 0,
		auto: false,
		//continuous: true,
		disableScroll: false,
		// stopPropagation: true,
		callback: function(index, element) {

		},
		transitionEnd: function(index, element) {
			switch(index) {
				case 0:
					hideForRocket();
					hideForDetail();
					hideForIndex3();
					showForRocket();
				break;
				case 1:
					hideForDetail();
					hideForRocket();
					hideForIndex3();
					showForDetail();
				break;
				case 2:
					hideForIndex3();
					hideForRocket();
					hideForDetail();
					showForIndex3();
				break;
				case 3:
					hideForIndex3();
					hideForRocket();
					hideForDetail();
				break;
			}
			dotList.removeClass("active");
			dotList.eq(index).addClass("active")
		}
	});
	// 默认激活第一个页面
	hideForRocket();
	showForRocket();

	/**
	* 运动函数
	*/
	function move(obj, json, time, step) {
		clearInterval(obj.timer);
		var step = !step ? 50 : step;
		var stepTime = time / step;
		for(var key in json) {
			var _obj = json[key];
			var curValue = parseInt(getStyle(obj, key));
			if(_obj.type === "percent") {
				key == "left" ? (
					_obj.value = _obj.value*bodyWidth) : (
						_obj.value = _obj.value*bodyHeight
					);
			}

			_obj.curValue = curValue;
			_obj.base = _obj.value > curValue ? 1 : 0; 
			_obj.speed = (_obj.value - curValue) / step;
			console.log(_obj, _obj.speed);
		}
		obj.timer = setInterval(function() {
			var isAllOk = true;
			for(var key in json) {
				var _obj = json[key];
				if(_obj.isOk) {
					continue;
				}

				var value = _obj.curValue;
				if(_obj.base && _obj.value <= value || !_obj.base && value <= _obj.value ) {
					_obj.isOk = true;
					obj.style[key] = _obj.value+"px";
					continue;
				}

				isAllOk = false;
				_obj.curValue += _obj.speed; 
				obj.style[key] = (_obj.curValue)+"px";
				//console.log(_obj.curValue);
			}

			if(isAllOk) {
				clearInterval(obj.timer);
			}
		}, stepTime);
	}	
    //getStyle()函数 用于兼容IE和FF：获取 对象的 非行间样式中的属性的值。 obj：元素对象。 name：属性名。
    function getStyle(obj,name){
        if(obj.currentStyle){
            return obj.currentStyle[name];//for IE
        }else{
            return getComputedStyle(obj,false)[name];//for FF
        }
    }